using System;
using System.Collections.Generic;
using System.Collections;

namespace Qnomad.Outlining {

	/// <summary>Provides utility methods for manipulating tree structures.</summary>
	/// <exclude/>
	public static class OutliningUtil {

		#region 'GenerateUniqueName' Method

		public static string GenerateUniqueName<T>( string newItemType , string nameProp, ICollection<T> parentColl ) {
			string result = null;
			bool isNameUnique = false;

			for ( int i = 0; !isNameUnique; i++ ) { //find a unique name to use
				result = (i == 0) ? "New " + newItemType : "New " + newItemType + " (" + i + ")";
				isNameUnique = true;
				foreach ( object existingItem in parentColl )
					if ( result.Equals(ReflectionExtentions.NavigateToOneSide(existingItem, nameProp)) )
						isNameUnique = false;
			}
			return result;
		}

		#endregion
	
	}
}
