﻿using System;
using System.Collections.Generic;
using Qnomad.PresentationModel;
using Qnomad.Demos.Dialog.DomainModel;

namespace Qnomad.Demos.Dialog.PresentationModel
{
	class PersonPM : ChangeNotifier
	{
		string name;
		public string Name
		{
			get { return name; }
			set { SetProperty( ref name, value, "Name" ); }
		}

		Color favoriteColor;
		public Color FavoriteColor
		{
			get { return favoriteColor; }
			set
			{
				SetProperty( ref favoriteColor, value, "FavoriteColor" );
				ShowMeaning();
			}
		}

		DialogPM message;
		public DialogPM Message
		{
			get { return message; }
			set { SetProperty( ref message, value, "Message" ); }
		}

		public void ShowMeaning()
		{
			if ( string.IsNullOrEmpty( Name ) || FavoriteColor == null )
				return;

			var text = string.Format( "{0} is a {1} person.\n Do you agree?", Name, FavoriteColor.Meaning );
			var caption = string.Format( "Meaning of {0}", FavoriteColor.Name );
			Message = new DialogPM( text, caption, new List<CommandPM> {
				new CommandPM( DialogPM.Yes, p => {} ),
				new CommandPM( DialogPM.No, p => Color.All.Remove(FavoriteColor) )
			} );
		}
	}
}
