using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;

using Qnomad.BidirectionalAssociations;

namespace Qnomad.Demos.PresentationModel {

	/// <summary>
	/// A parent class that contains a list of child <see cref="SampleItem"/> objects.
	/// </summary>
	public class SampleListContainer {
		private ObservableCollection<SampleItem> sampleList;

		public SampleListContainer() {
			SampleList = new ObservableCollection<SampleItem>();
		}

		public ObservableCollection<SampleItem> SampleList {
			get { return sampleList; }
			protected set {
				sampleList = value;
				((INotifyCollectionChanged)sampleList).CollectionChanged +=
					new OneToManyAssocSync( this, "ParentListContainer" ).UpdateManySide;
			}
		}
	}
}
