using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

using Qnomad.Demos.PresentationModel.GUI.Model;
using System.Collections.Specialized;

namespace Qnomad.Demos.PresentationModel.GUI {

	/// <summary>
	/// Interaction logic for Demo1.xaml
	/// </summary>
	public partial class Demo1 : System.Windows.Controls.UserControl {
		private IList<Demo1ItemPM> displayedItems = new ObservableCollection<Demo1ItemPM>();

		public Demo1() {
			InitializeComponent();

			ObservableCollection<SampleItem> domainList = App.SampleListContainer.SampleList;
			foreach ( SampleItem item in domainList ) //build sample presentation-model objects:
				displayedItems.Add( new Demo1ItemPM(item) );
			domainList.CollectionChanged += domainList_CollectionChanged; //listen for future changes
			sampleListBox.ItemsSource = displayedItems; //bind presentation-model to UI
		}

		private void editableContentControl_ButtonClick( object sender, RoutedEventArgs args ) {
			Button clickedButton = (Button)args.OriginalSource;
			ContentControl targetContentCtrl = (ContentControl)sender;
			Demo1ItemPM targetItem = (Demo1ItemPM)targetContentCtrl.DataContext;
			string changeTemplateTo = "defaultTemplate";

			if ( "editButton".Equals( clickedButton.Name ) )
				changeTemplateTo = "editTextTemplate";
			else if ( "saveButton".Equals( clickedButton.Name ) ) {
				targetItem.DomainItem.Name = targetItem.UnsavedName;
				//this is where you'd persist changes to the database
			} else if ( "cancelButton".Equals( clickedButton.Name ) )
				targetItem.UnsavedName = targetItem.DomainItem.Name;

			targetContentCtrl.ContentTemplate =
				(DataTemplate)targetContentCtrl.Style.Resources[changeTemplateTo];
			targetItem.IsSelected = true;
			targetContentCtrl.Focus();
		}

		private void domainList_CollectionChanged( object sender, NotifyCollectionChangedEventArgs args ) {
			if ( args.Action == NotifyCollectionChangedAction.Add )
				foreach ( SampleItem addingToCollection in args.NewItems )
					displayedItems.Add( new Demo1ItemPM( addingToCollection ) );
			else if ( args.Action == NotifyCollectionChangedAction.Remove )
				foreach ( SampleItem removingFromCollection in args.OldItems )
					foreach ( Demo1ItemPM v in displayedItems )
						if ( v.DomainItem == removingFromCollection )
							{ displayedItems.Remove( v ); return; }
		}
	}
}
